#ifndef __FTSTDLIB_H__
#define __FTSTDLIB_H__

/* only when building */
#ifdef FT2_BUILD_LIBRARY
#include <u.h>
#include <libc.h>
#include <bio.h>
#define NULL	nil
#define	SEEK_CUR	1
#define	SEEK_END	2
#define	SEEK_SET	0
#endif
typedef unsigned long size_t;
typedef long ptrdiff_t;
typedef ptrdiff_t ft_ptrdiff_t;

#define SHRT_MAX	0x7fff
#define SHRT_MIN	0x8000
#define INT_MAX		0x7fffffff
#define INT_MIN		0x80000000

#define FT_CHAR_BIT   8
#define FT_INT_MAX    INT_MAX
#define FT_INT_MIN    INT_MIN

#define FT_USHORT_MAX	0xffffU
#define FT_UINT_MAX	0xffffffffU
#define FT_ULONG_MAX	0xffffffffUL

#define ft_memchr   memchr
#define ft_memcmp   memcmp
#define ft_memcpy   memcpy
#define ft_memmove  memmove
#define ft_memset   memset
#define ft_strcat   strcat
#define ft_strcmp   strcmp
#define ft_strcpy   strcpy
#define ft_strlen   strlen
#define ft_strncmp  strncmp
#define ft_strncpy  strncpy
#define ft_strrchr  strrchr
#define ft_strstr   strstr

#define FT_FILE			Biobuf
#define ft_fclose(bio)		Bterm((bio))
#define ft_fopen(s, m)		Bopen((s), OREAD)
#define ft_fread(b, x, n, bio)	Bread((bio), (b), (n))
#define ft_fseek(bio, n, t)	Bseek((bio), (n), (t))
#define ft_ftell(bio)    	Boffset((bio))
#define ft_sprintf  		sprint
#define sprintf			sprint

/*
#define FT_FILE     FILE
#define ft_fclose   fclose
#define ft_fopen    fopen
#define ft_fread    fread
#define ft_fseek    fseek
#define ft_ftell    ftell
#define ft_sprintf  sprintf
*/

#define ft_qsort  qsort

#define ft_exit(x)	exits((x)? "ft2error": nil)
#define ft_scalloc   calloc
#define ft_sfree     free
#define ft_smalloc   malloc
#define ft_srealloc  realloc


#define ft_atol   atol
#define ft_labs   labs

#define ft_jmp_buf     jmp_buf  /* note: this cannot be a typedef since */
                                /*       jmp_buf is defined as a macro  */
                                /*       on certain platforms           */

#define ft_longjmp     longjmp
#define ft_setjmp( b ) setjmp( *(jmp_buf*) &(b) )    /* same thing here */

#endif /* __FTSTDLIB_H__ */
